package de.intevation.flys.artifacts.model.minfo;

import org.apache.poi.hssf.record.formula.functions.T;

import com.vividsolutions.jts.densify.Densifier;

import gnu.trove.TDoubleArrayList;
import de.intevation.flys.artifacts.model.DateRange;


public class BedBedQualityResult
extends BedQualityResult {

    protected TDoubleArrayList diameterCap;
    protected TDoubleArrayList diameterSub;
    protected TDoubleArrayList porosityCap;
    protected TDoubleArrayList porositySub;
    protected TDoubleArrayList loadDensityCap;
    protected TDoubleArrayList loadDensitySub;

    public BedBedQualityResult(
        String type,
        TDoubleArrayList diameterCap,
        TDoubleArrayList diameterSub,
        TDoubleArrayList km,
        DateRange range,
        TDoubleArrayList porosityCap,
        TDoubleArrayList porositySub,
        TDoubleArrayList loadDensityCap,
        TDoubleArrayList loadDensitySub
    ) {
        super(type, null, km, range);
        this.diameterCap = diameterCap;
        this.diameterSub = diameterSub;
        this.porosityCap = porosityCap;
        this.porositySub = porositySub;
        this.loadDensityCap = loadDensityCap;
        this.loadDensitySub = loadDensitySub;
    }

    public double getPorosityCap(int ndx) {
        return porosityCap.get(ndx);
    }

    public double getPorositySub(int ndx) {
        return porositySub.get(ndx);
    }

    public double getLoadDensityCap(int ndx) {
        return loadDensityCap.get(ndx);
    }

    public double getLoadDensitySub(int ndx) {
        return loadDensitySub.get(ndx);
    }

    public double getDiameterCap(int ndx) {
        return diameterCap.get(ndx);
    }

    public double getDiameterSub(int ndx) {
        return diameterSub.get(ndx);
    }
    
    public double[][] getDiameterCapData() {
        return new double[][] {
            kms.toNativeArray(),
            diameterCap.toNativeArray()
        };
    }
    
    public double[][] getDiameterSubData() {
        return new double[][] {
            kms.toNativeArray(),
            diameterSub.toNativeArray()
        };
    }
    
    public double[][] getPorosityTopLayerData() {
        return new double[][] {
            kms.toNativeArray(),
            porosityCap.toNativeArray()
        };
    }
    
    public double[][] getPorositySubLayerData() {
        return new double[][] {
            kms.toNativeArray(),
            porositySub.toNativeArray()
        };
    }
    
    public double[][] getDensityTopLayerData() {
        return new double[][] {
            kms.toNativeArray(),
            loadDensityCap.toNativeArray()
        };
    }
    
    public double[][] getDensitySubLayerData() {
        return new double[][] {
            kms.toNativeArray(),
            loadDensitySub.toNativeArray()
        };
    }
}
